@echo off
if "%1"=="" goto no_rom
if not exist %1 goto no_rom

bin\deltree %1.dump >nul
bin\deltree temp.bin.patched.dump >nul
if exist temp.bin del temp.bin >nul
if exist temp.bin.patched del temp.bin.patched >nul
if exist %1.patched del %1.patched >nul
if exist address del address >nul
if exist checksum del checksum >nul
if exist attrib del attrib >nul

rem **** capsule magic stolen from UBU ****
bin\uefifind header count 8BA63C4A2377FB48803D578CC1FEC44D %1>nul && bin\UEFIExtract %1 4A3CA68B-7723-48FB-803D-578CC1FEC44D>nul && echo Capsule detected

if exist %1.dump\body.bin (
    move /y %1.dump\body.bin temp.bin >nul
    set bios0=temp.bin
    set bios=temp.bin.patched
    set asus=1
) else (
    set bios0=%1
    set bios=%1.patched
    set asus=0
)

bin\hexfind 8d8cc698040400 %bios0%>nul && copy /y %bios0% %bios%
if not exist %bios% goto exit

bin\sfk replace %bios% -binary /8d8cc698040400/8d8cc658080800/ /8db800000400/8db800000800/ /bec0010000/be80030000/ -yes

set string=0
bin\hexfind 5300690049006e00690074 %bios%>nul && set string=1
set full=0
bin\hexfind FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5AA5 %bios%>nul && set full=1

set mod=CpuMpPei
set guid=EDADEB9D-DDBA-48BD-9D22-C1C169C8C5C6
call :findjob

if %attrib_CpuMpPei%==64 bin\hexalter %bios% 0x%adr_CpuMpPei%=0x%chksum_CpuMpPei%


if %asus%==1 (
	echo Restore Capsule
	copy /b /y %1.dump\header.bin + %bios% %1.patched >nul
        bin\deltree %1.dump >nul
        bin\deltree %bios%.dump >nul
        del %bios%
        del %bios0%
)

bin\deltree %bios%.dump >nul
del address
del checksum
del attrib
pause
goto exit:

:findjob
bin\UEFIExtract %bios% %guid% >nul
if %string%==1 (
	if %full%==1 (
		bin\cat "%bios%.dump/BIOS region/%mod%/info.txt"|bin\grep "Offset:"|bin\sed "s/Offset: //;s/.$//" > address
		bin\cat "%bios%.dump/BIOS region/%mod%/info.txt"|bin\grep "Data checksum valid:"|bin\sed "s/Data checksum valid: //;s/.$//" > checksum
		bin\cat "%bios%.dump/BIOS region/%mod%/info.txt"|bin\grep "Attributes:"|bin\sed "s/Attributes: //;s/.$//" > attrib
	) else (
		bin\cat "%bios%.dump/%mod%/info.txt"|bin\grep "Offset:"|bin\sed "s/Offset: //;s/.$//" > address
		bin\cat "%bios%.dump/%mod%/info.txt"|bin\grep "Data checksum valid:"|bin\sed "s/Data checksum valid: //;s/.$//" > checksum
		bin\cat "%bios%.dump/%mod%/info.txt"|bin\grep "Attributes:"|bin\sed "s/Attributes: //;s/.$//" > attrib
	)
) else (
	if %full%==1 (
		bin\cat "%bios%.dump/BIOS region/%guid%/info.txt"|bin\grep "Offset:"|bin\sed "s/Offset: //;s/.$//" > address
		bin\cat "%bios%.dump/BIOS region/%guid%/info.txt"|bin\grep "Data checksum valid:"|bin\sed "s/Data checksum valid: //;s/.$//" > checksum
		bin\cat "%bios%.dump/BIOS region/%guid%/info.txt"|bin\grep "Attributes:"|bin\sed "s/Attributes: //;s/.$//" > attrib
	) else (
		bin\cat "%bios%.dump/%guid%/info.txt"|bin\grep "Offset:"|bin\sed "s/Offset: //;s/.$//" > address
		bin\cat "%bios%.dump/%guid%/info.txt"|bin\grep "Data checksum valid:"|bin\sed "s/Data checksum valid: //;s/.$//" > checksum
		bin\cat "%bios%.dump/%guid%/info.txt"|bin\grep "Attributes:"|bin\sed "s/Attributes: //;s/.$//" > attrib
	)
)

for /f %%a in ('bin\cat address') do set adr_%mod%=%%a
for /f %%a in ('bin\cat checksum') do set chksum_%mod%=%%a
for /f %%a in ('bin\cat attrib') do set /a attrib_%mod% = 0x%%a "&" 0x40
exit /b

:no_rom
echo ........................................
echo Usage:  pcie_patcher.cmd BIOSNAME
echo Result: BIOSNAME.patched
echo ........................................
pause>nul

:exit
